## julia 1.0.4+dfsg

=== debian/changelog ===
julia (1.0.4+dfsg-1) unstable; urgency=medium

  * New upstream version 1.0.4+dfsg
  * Uscan: Monitor the 1.0.X series.
  * Upgrade embedded Pkg.jl -> 1609a05aee5d5960670738d8d834d91235bd6b1e

 -- Mo Zhou <cdluminate@gmail.com>  Fri, 17 May 2019 09:01:01 +0000

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%julia-$1.tar.gz%,\
      dversionmangle=s/\+dfsg\d*$// ,repacksuffix=+dfsg" \
    https://github.com/JuliaLang/julia/tags \
    (?:.*?/)?v?(1\.0[\d.]*)\.tar\.gz debian uupdate

## julia 1.1.1+dfsg

=== debian/changelog ===
julia (1.1.1+dfsg-1) unstable; urgency=medium

  * New upstream version 1.1.1+dfsg
  * Bump Standards-Version to 4.4.0 (no change).
  * Add update-jl.sh script for managing embedded sources.
    + Update embedded Pkg.jl to 40cbbe224d4a491503279dfc5b9aefe15412f007.
    + Update embedded Documenter.jl to 0.23.0
    + Update embedded JSON.jl to 0.21.0
    + Update embedded DocStringExtensions.jl to 0.8.0
    + Embed DocumenterlaTeX.jl 0.2.0
    + Embed Parsers.jl 0.3.6
    * Re-apply the privacy-breach.patch to the embedded .jl packages.
  * Disable the flaky PDF build and remove the doc-base file.
  * Apply wrap-and-sort.

 -- Mo Zhou <cdluminate@gmail.com>  Thu, 25 Jul 2019 14:12:44 +0000

julia (1.1.0+dfsg-1) experimental; urgency=medium

  [ Mo Zhou ]
  * New upstream version 1.1.0+dfsg
  * shlibdeps.mk: remove unused arpack part.
  * B-D: Require llvm-6.0-dev (>= 1:6.0.1-11).
  * Remove patches merged upstream and refresh patches:
    - appstream.patch
    - test-skip-i386-spec.patch
  * Update the embedded source or source tarballs:
    + libuv, Pkg.jl, Documenter.jl (= 0.22.1), DocumenterLatex.jl (= 0.2.0),
      DocStringExtensions (= 0.7.0), JSON.jl (= 0.20.0).
  * Refresh symbols list for libjulia1.
  * Switch back to use system LLVM:
    + Set USE_SYSTEM_LLVM=1.
    + Add makefile options for system LLVM.
    + Add DESTDIR argument to makefile options.
    + Build-Depends on system LLVM-6.0.
    - Remove the embedded LLVM-6.0.0 tarball and update include-binaries.
    - Remove cmake and python3 from Build-Depends since they are for LLVM.
    - Remove copyright paragraph for the embedded LLVM.
    - Remove the LLVM installation hack from rules.
    - Remove hacky patches for related to the embedded LLVM.
      - install-embedded-llvm-hack.patch
      - install-julia-hack.patch

  [ Salsa Pipeline ]
  * Update salsa CI pipeline

 -- Mo Zhou <cdluminate@gmail.com>  Thu, 04 Apr 2019 04:25:04 +0000

=== debian/control ===
Source: julia
Section: science
Homepage: https://julialang.org
Priority: optional
Standards-Version: 4.4.0
Vcs-Git: https://salsa.debian.org/julia-team/julia.git
Vcs-Browser: https://salsa.debian.org/julia-team/julia
Maintainer: Debian Julia Team <pkg-julia-devel@lists.alioth.debian.org>
Uploaders: Peter Colberg <peter@colberg.org>,
           Graham Inggs <ginggs@debian.org>,
           Mo Zhou <cdluminate@gmail.com>
Build-Depends: curl,
               debhelper (>= 11~),
               dpkg-dev (>= 1.16.2~),
               libblas-dev | libblas.so,
               libcurl4-gnutls-dev | libcurl-dev,
               libdsfmt-dev (>= 2.2.3),
               libgit2-dev (>= 0.27.0~),
               libgmp-dev,
               liblapack-dev | liblapack.so,
               libmbedtls-dev,
               libmpfr-dev,
               libopenblas-dev [amd64 arm64 armhf i386 kfreebsd-amd64 kfreebsd-i386 mips64el ppc64el s390x],
               libopenlibm-dev (>= 0.4.1+dfsg-4~) [any-i386 any-amd64 arm64 armhf mips mips64el mipsel powerpc ppc64 ppc64el],
               libpcre2-dev (>= 10.20-3~),
               libsuitesparse-dev (>= 1:4.4.5),
               libunwind8-dev [!s390x],
               libutf8proc-dev (>= 2.1.1),
               llvm-6.0-dev (>= 1:6.0.1-11),
               openssl,
               unicode-data
Build-Depends-Indep: fonts-lato,
                     latexmk,
                     python3-pkg-resources,
                     python3-pygments,
                     texlive,
                     texlive-extra-utils,
                     texlive-fonts-extra,
                     texlive-latex-base,
                     texlive-latex-extra,
                     texlive-latex-recommended,
                     texlive-luatex,
                     texlive-plain-generic

Package: julia
Architecture: any
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: julia-common (= ${source:Version}),
         libjulia1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Replaces: julia-common (<< 0.5.0~)
Breaks: julia-common (<< 0.5.0~)
Suggests: ess (>= 12.09-1~), julia-doc, vim-julia
Recommends: git, openssl
Description: high-performance programming language for technical computing
 Julia is a high-level, high-performance dynamic programming language for
 technical computing, with syntax that is familiar to users of other technical
 computing environments. It provides a sophisticated compiler, distributed
 parallel execution, numerical accuracy, and an extensive mathematical function
 library. The library, mostly written in Julia itself, also integrates mature,
 best-of-breed C and Fortran libraries for linear algebra, random number
 generation, FFTs, and string processing. Julia programs are organized around
 defining functions, and overloading them for different combinations of
 argument types (which can also be user-defined).
 .
 This package provides a complete Julia installation (JIT compiler, standard
 library, text-based user interface).

Package: libjulia1
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Replaces: julia (<< 0.5.0~), libjulia0.6, libjulia0.7
Breaks: julia (<< 0.5.0~), libjulia0.6, libjulia0.7
Depends: libopenblas-base [amd64 arm64 armhf i386 kfreebsd-amd64 kfreebsd-i386 mips64el ppc64el s390x] | libatlas3-base [amd64 arm64 armel armhf hurd-i386 i386 kfreebsd-amd64 kfreebsd-i386 mips mips64el mipsel ppc64el s390x] | libmkl-rt [amd64 i386],
         libopenblas-dev [amd64 arm64 armhf i386 kfreebsd-amd64 kfreebsd-i386 mips64el ppc64el s390x] | libatlas-base-dev [amd64 arm64 armel armhf hurd-i386 i386 kfreebsd-amd64 kfreebsd-i386 mips mips64el mipsel ppc64el s390x] | libmkl-dev [amd64 i386],
         ${misc:Depends},
         ${shlibs:Depends}
Description: high-performance programming language for technical computing (runtime library)
 Julia is a high-level, high-performance dynamic programming language for
 technical computing, with syntax that is familiar to users of other technical
 computing environments. It provides a sophisticated compiler, distributed
 parallel execution, numerical accuracy, and an extensive mathematical function
 library. The library, mostly written in Julia itself, also integrates mature,
 best-of-breed C and Fortran libraries for linear algebra, random number
 generation, FFTs, and string processing. Julia programs are organized around
 defining functions, and overloading them for different combinations of
 argument types (which can also be user-defined).
 .
 This package provides the Julia runtime library.

Package: julia-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Replaces: julia (<< 0.4.1-1~)
Breaks: julia (<< 0.4.1-1~)
Recommends: julia
Description: high-performance programming language for technical computing (common files)
 Julia is a high-level, high-performance dynamic programming language for
 technical computing, with syntax that is familiar to users of other technical
 computing environments. It provides a sophisticated compiler, distributed
 parallel execution, numerical accuracy, and an extensive mathematical function
 library. The library, mostly written in Julia itself, also integrates mature,
 best-of-breed C and Fortran libraries for linear algebra, random number
 generation, FFTs, and string processing. Julia programs are organized around
 defining functions, and overloading them for different combinations of
 argument types (which can also be user-defined).
 .
 This package contains the Julia standard library and test suite.

Package: libjulia-dev
Section: libdevel
Architecture: any
Depends: libjulia1 (= ${binary:Version}), ${misc:Depends}
Description: high-performance programming language for technical computing (development)
 Julia is a high-level, high-performance dynamic programming language for
 technical computing, with syntax that is familiar to users of other technical
 computing environments. It provides a sophisticated compiler, distributed
 parallel execution, numerical accuracy, and an extensive mathematical function
 library. The library, mostly written in Julia itself, also integrates mature,
 best-of-breed C and Fortran libraries for linear algebra, random number
 generation, FFTs, and string processing. Julia programs are organized around
 defining functions, and overloading them for different combinations of
 argument types (which can also be user-defined).
 .
 This package provides the Julia runtime headers.

Package: julia-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: fonts-font-awesome,
         fonts-inconsolata,
         libjs-highlight.js,
         libjs-jquery,
         libjs-jquery-ui,
         libjs-lodash,
         libjs-mathjax,
         libjs-requirejs,
         node-highlight.js,
         node-normalize.css,
         ${misc:Depends}
Suggests: julia
Description: high-performance programming language for technical computing (documentation)
 Julia is a high-level, high-performance dynamic programming language for
 technical computing, with syntax that is familiar to users of other technical
 computing environments. It provides a sophisticated compiler, distributed
 parallel execution, numerical accuracy, and an extensive mathematical function
 library. The library, mostly written in Julia itself, also integrates mature,
 best-of-breed C and Fortran libraries for linear algebra, random number
 generation, FFTs, and string processing. Julia programs are organized around
 defining functions, and overloading them for different combinations of
 argument types (which can also be user-defined).
 .
 This package contains the Julia manual, which describes the language and its
 standard library. It also contains example Julia programs.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/default.mk
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# Disable unaligned access on armhf
ifneq (,$(filter $(DEB_HOST_ARCH),armhf))
	export DEB_CFLAGS_MAINT_APPEND += -mno-unaligned-access
endif

# Ensure pcre_h.jl and errno_h.jl are sorted reproducibly
export LC_ALL=C.UTF-8
# HOME is needed to avoid "mkdir(): Permission denied" while building docs.
# Some tests also need a HOME directory.
export HOME=/tmp
# If you want to do a custom build of Julia against MKL, set it to 1.
export CUSTOM_MKL ?= 0
# If you want to do a custom build for native machine architecture
export CUSTOM_NATIVE ?= 0

LLVM_VER = $(shell grep -e 'llvm-.*-dev' debian/control | cut -d- -f2)

# NOTES:
# 1. Some of these flags come from upstream's Make.inc .
# 2. To enable USE_BLAS64=0 (ILP64), we need to set INTERFACE64=1 for OpenBLAS.
# 3. Julia is tightly coupled with a specific libuv1 version. we cannot use the one provided in archive.
# 4. ∴ is unicode "therefore", ⛬  is unicode "historic site" https://unicode-table.com/en/26EC/
COMMON_FLAGS = \
	prefix=/usr \
	sysconfdir=/etc \
	DESTDIR=debian/tmp/ \
	LLVM_CONFIG=/usr/bin/llvm-config-$(LLVM_VER) \
	LLVM_VER=$(LLVM_VER) \
	MULTIARCH=$(DEB_HOST_MULTIARCH) \
	MULTIARCH_INSTALL=1 \
	NO_GIT=1 \
	TAGGED_RELEASE_BANNER='$(DEB_VENDOR) ⛬  julia/$(DEB_VERSION)' \
	USE_BLAS64=0  \
	USE_LLVM_SHLIB=1 \
	USE_SYSTEM_BLAS=1 \
	USE_SYSTEM_CURL=1 \
	USE_SYSTEM_DSFMT=1 \
	USE_SYSTEM_GMP=1 \
	USE_SYSTEM_LAPACK=1 \
	USE_SYSTEM_LIBGIT2=1 \
	USE_SYSTEM_LIBSSH2=1 \
	USE_SYSTEM_LIBUNWIND=1 \
	USE_SYSTEM_LIBUV=0 \
	USE_SYSTEM_LLVM=1 \
	USE_SYSTEM_MBEDTLS=1 \
	USE_SYSTEM_MPFR=1 \
	USE_SYSTEM_OPENSPECFUN=1 \
	USE_SYSTEM_PATCHELF=1 \
	USE_SYSTEM_PCRE=1 \
	USE_SYSTEM_SUITESPARSE=1 \
	USE_SYSTEM_UTF8PROC=1 \
	VERBOSE=1

# Set architecture specific CPU targets. See: #910784
ifneq (,$(filter $(DEB_HOST_ARCH),amd64 kfreebsd-amd64 x32))
COMMON_FLAGS += MARCH=x86-64 \
	JULIA_CPU_TARGET="generic;sandybridge,-xsaveopt,clone_all;haswell,-rdrnd,base(1)"
else ifneq (,$(filter $(DEB_HOST_ARCH),i386 hurd-i386 kfreebsd-i386))
COMMON_FLAGS += MARCH=pentium4 \
	JULIA_CPU_TARGET="pentium4;sandybridge,-xsaveopt,clone_all"
else ifneq (,$(filter $(DEB_HOST_ARCH),armhf))
COMMON_FLAGS += JULIA_CPU_TARGET="armv7-a;armv7-a,neon;armv7-a,neon,vfp4"
else ifneq (,$(filter $(DEB_HOST_ARCH),ppc64el))
COMMON_FLAGS += JULIA_CPU_TARGET="pwr8"
else
COMMON_FLAGS += JULIA_CPU_TARGET="generic"
endif

# Use libopenlibm on architectures that have it
ifneq (,$(filter $(DEB_HOST_ARCH),amd64 kfreebsd-amd64 x32))
COMMON_FLAGS += USE_SYSTEM_OPENLIBM=1 USE_SYSTEM_LIBM=0
else ifneq (,$(filter $(DEB_HOST_ARCH),i386 hurd-i386 kfreebsd-i386))
COMMON_FLAGS += USE_SYSTEM_OPENLIBM=1 USE_SYSTEM_LIBM=0
else ifneq (,$(filter $(DEB_HOST_ARCH),arm64 armhf mips mips64el mipsel powerpc ppc64 ppc64el))
COMMON_FLAGS += USE_SYSTEM_OPENLIBM=1 USE_SYSTEM_LIBM=0
else
# Use libm elsewhere
COMMON_FLAGS += USE_SYSTEM_OPENLIBM=0 USE_SYSTEM_LIBM=1
endif

# Use libopenblas on architectures that have it
ifneq (,$(filter $(DEB_HOST_ARCH),amd64 arm64 armhf i386 kfreebsd-amd64 kfreebsd-i386 mips64el ppc64el s390x))
COMMON_FLAGS += LIBBLAS=-lopenblas LIBBLASNAME=libopenblas \
                LIBLAPACK=-lopenblas LIBLAPACKNAME=libopenblas
else
# Use libblas and liblapack elsewhere
COMMON_FLAGS += LIBBLAS=-lblas LIBBLASNAME=libblas \
                LIBLAPACK=-llapack LIBLAPACKNAME=liblapack
endif

# [s390x] Disable libunwind
ifneq (,$(filter $(DEB_HOST_ARCH),s390x))
COMMON_FLAGS += DISABLE_LIBUNWIND=1
endif

# Set number of parallel workers for tests
ifneq (,$(filter parallel=1,$(DEB_BUILD_OPTIONS)))
TESTS_ENV += JULIA_CPU_THREADS=2
else ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
TESTS_ENV += JULIA_CPU_THREADS=$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
TESTS_ENV += JULIA_CPU_THREADS=2
endif
# Restart workers exceeding maximum resident memory size (requires JULIA_CPU_THREADS >= 2)
TESTS_ENV += JULIA_TEST_MAXRSS_MB=500

ifeq (1,$(CUSTOM_MKL))
COMMON_FLAGS += USE_INTEL_MKL=1 USE_BLAS64=1 \
                LIBBLAS=-lmkl_rt LIBBLASNAME=libmkl_rt \
                LIBLAPACK=-lmkl_rt LIBLAPACKNAME=libmkl_rt \
				MKLROOT=/usr MKLLIB=/usr/lib/$(DEB_HOST_MULTIARCH)
endif
ifeq (1,$(CUSTOM_NATIVE))
COMMON_FLAGS += MARCH=native JULIA_CPU_TARGET=native
endif


%:
	dh $@

override_dh_auto_build-arch:
	dh_auto_build -- $(COMMON_FLAGS)

override_dh_auto_build-indep:
	dh_auto_build -- $(COMMON_FLAGS)
	#-$(MAKE) -C doc pdf

override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
ifeq (,$(filter $(DEB_HOST_ARCH),amd64 i386))
	-env $(TESTS_ENV) make -C test $(COMMON_FLAGS)
else
	env $(TESTS_ENV) make -C test $(COMMON_FLAGS)
endif
endif

override_dh_auto_test-indep:

override_dh_auto_clean:
	make $(COMMON_FLAGS) distcleanall
	make -f debian/shlibdeps.mk $(COMMON_FLAGS) clean

override_dh_auto_install:
	make $(COMMON_FLAGS) install
	rm -rf usr # Otherwise dh_install does not see debian/tmp/usr
	find debian -type f -name '*.so.debug' -delete
	find debian -type f -name .gitignore -delete
	find debian -type f -name 'LICENSE.md' -delete

override_dh_missing:
	dh_missing --list-missing

override_dh_link-arch:
	# Create *.so symlinks for dlopen'd libraries in private libdir.
	make -f debian/shlibdeps.mk $(COMMON_FLAGS)
	dh_link

override_dh_shlibdeps:
	# Generate dependencies for dlopen'd libraries using dummy executable.
	# Suppress useless dependency warnings caused by unused library symbols.
	dh_shlibdeps -- --warnings=1 debian/shlibdeps

override_dh_compress:
	dh_compress --exclude=examples/

override_dh_install-indep:
	dh_install --exclude=build_h.jl --exclude=build.h

override_dh_fixperms:
	dh_fixperms
	# Fix shebang and mode bits
	find debian \( -type f -name '*.jl' \
		-exec grep -q '..usr/bin/env julia' '{}' \; \
		-a -exec sed -i -e 's@#!/usr/bin/env julia@#!/usr/bin/julia@g' '{}' \; \
		-a -exec chmod +x '{}' \; -print \)

# Don't strip sys.so and libjulia.so.* to keep the sanity of this program.
# https://github.com/JuliaLang/julia/issues/23115#issuecomment-320715030
#
# Julia sysimage (i.e. sys.so) sys.so is NOT compiled from any compiled
# language such as C/C++, but from Julia scripts instead. Julia precompiles .jl
# scripts under the base and stdlib directories into this ELF-formated shared
# object sys.so to speedup program startup time. A glance at the symbol table
# (readelf -sW sys.so) would illustrate that. For more detail about how such
# debugging information is useful, please refer the official documentation:
# https://docs.julialang.org/en/v1.0.0/manual/stacktraces/
#
override_dh_strip:
	dh_strip -X"sys.so"

override_dh_makeshlibs:
	dh_makeshlibs --no-scripts -XLLVM

## julia 1.3.0+dfsg

=== Makefile ===
JULIAHOME := $(abspath $(dir $(lastword $(MAKEFILE_LIST))))
include $(JULIAHOME)/Make.inc

VERSDIR := v`cut -d. -f1-2 < $(JULIAHOME)/VERSION`

default: $(JULIA_BUILD_MODE) # contains either "debug" or "release"
all: debug release

# sort is used to remove potential duplicates
DIRS := $(sort $(build_bindir) $(build_depsbindir) $(build_libdir) $(build_private_libdir) $(build_libexecdir) $(build_includedir) $(build_includedir)/julia $(build_sysconfdir)/julia $(build_datarootdir)/julia $(build_datarootdir)/julia/stdlib $(build_man1dir))
ifneq ($(BUILDROOT),$(JULIAHOME))
BUILDDIRS := $(BUILDROOT) $(addprefix $(BUILDROOT)/,base src src/flisp src/support src/clangsa ui doc deps stdlib test test/embedding test/llvmpasses)
BUILDDIRMAKE := $(addsuffix /Makefile,$(BUILDDIRS)) $(BUILDROOT)/sysimage.mk
DIRS := $(DIRS) $(BUILDDIRS)
$(BUILDDIRMAKE): | $(BUILDDIRS)
	@# add Makefiles to the build directories for convenience (pointing back to the source location of each)
	@echo '# -- This file is automatically generated in julia/Makefile -- #' > $@
	@echo 'BUILDROOT=$(BUILDROOT)' >> $@
	@echo 'include $(JULIAHOME)$(patsubst $(BUILDROOT)%,%,$@)' >> $@
julia-deps: | $(BUILDDIRMAKE)
configure-y: | $(BUILDDIRMAKE)
configure:
ifeq ("$(origin O)", "command line")
	@if [ "$$(ls '$(BUILDROOT)' 2> /dev/null)" ]; then \
		echo 'WARNING: configure called on non-empty directory $(BUILDROOT)'; \
		read -p "Proceed [y/n]? " answer; \
	else \
		answer=y;\
	fi; \
	[ $$answer = 'y' ] && $(MAKE) configure-$$answer
else
	$(error "cannot rerun configure from within a build directory")
endif
else
configure:
	$(error "must specify O=builddir to run the Julia `make configure` target")
endif

$(foreach dir,$(DIRS),$(eval $(call dir_target,$(dir))))
$(foreach link,base $(JULIAHOME)/test,$(eval $(call symlink_target,$(link),$$(build_datarootdir)/julia,$(notdir $(link)))))

julia_flisp.boot.inc.phony: julia-deps
	@$(MAKE) $(QUIET_MAKE) -C $(BUILDROOT)/src julia_flisp.boot.inc.phony

# Build the HTML docs (skipped if already exists, notably in tarballs)
$(BUILDROOT)/doc/_build/html/en/index.html: $(shell find $(BUILDROOT)/base $(BUILDROOT)/doc \( -path $(BUILDROOT)/doc/_build -o -path $(BUILDROOT)/doc/deps -o -name *_constants.jl -o -name *_h.jl -o -name version_git.jl \) -prune -o -type f -print)
	@$(MAKE) docs

julia-symlink: julia-ui-$(JULIA_BUILD_MODE)
ifeq ($(OS),WINNT)
	@echo '@"%~dp0"\'"$(shell $(JULIAHOME)/contrib/relative_path.sh "$(BUILDROOT)" "$(JULIA_EXECUTABLE)" | tr / '\\')" '%*' > $(BUILDROOT)/julia.bat
	chmod a+x $(BUILDROOT)/julia.bat
else
ifndef JULIA_VAGRANT_BUILD
	@ln -sf "$(shell $(JULIAHOME)/contrib/relative_path.sh "$(BUILDROOT)" "$(JULIA_EXECUTABLE)")" $(BUILDROOT)/julia
endif
endif

julia-deps: | $(DIRS) $(build_datarootdir)/julia/base $(build_datarootdir)/julia/test
	@$(MAKE) $(QUIET_MAKE) -C $(BUILDROOT)/deps

julia-stdlib: | $(DIRS)
	@$(MAKE) $(QUIET_MAKE) -C $(BUILDROOT)/stdlib

julia-base: julia-deps $(build_sysconfdir)/julia/startup.jl $(build_man1dir)/julia.1 $(build_datarootdir)/julia/julia-config.jl
	@$(MAKE) $(QUIET_MAKE) -C $(BUILDROOT)/base

julia-libccalltest: julia-deps
	@$(MAKE) $(QUIET_MAKE) -C $(BUILDROOT)/src libccalltest

julia-libllvmcalltest: julia-deps
	@$(MAKE) $(QUIET_MAKE) -C $(BUILDROOT)/src libllvmcalltest

julia-src-release julia-src-debug : julia-src-% : julia-deps julia_flisp.boot.inc.phony
	@$(MAKE) $(QUIET_MAKE) -C $(BUILDROOT)/src libjulia-$*

julia-ui-release julia-ui-debug : julia-ui-% : julia-src-%
	@$(MAKE) $(QUIET_MAKE) -C $(BUILDROOT)/ui julia-$*

julia-sysimg-ji : julia-stdlib julia-base julia-ui-$(JULIA_BUILD_MODE) | $(build_private_libdir)
	@$(MAKE) $(QUIET_MAKE) -C $(BUILDROOT) -f sysimage.mk sysimg-ji JULIA_EXECUTABLE='$(JULIA_EXECUTABLE)'

julia-sysimg-release julia-sysimg-debug : julia-sysimg-% : julia-sysimg-ji julia-ui-%
	@$(MAKE) $(QUIET_MAKE) -C $(BUILDROOT) -f sysimage.mk sysimg-$*

julia-debug julia-release : julia-% : julia-sysimg-% julia-symlink julia-libccalltest julia-libllvmcalltest julia-base-cache

debug release : % : julia-%

docs: julia-sysimg-$(JULIA_BUILD_MODE)
	@$(MAKE) $(QUIET_MAKE) -C $(BUILDROOT)/doc JULIA_EXECUTABLE='$(call spawn,$(JULIA_EXECUTABLE_$(JULIA_BUILD_MODE)))'

check-whitespace:
ifneq ($(NO_GIT), 1)
	@$(JULIAHOME)/contrib/check-whitespace.sh
else
	$(warn "Skipping whitespace check because git is unavailable")
endif

release-candidate: release testall
	@$(JULIA_EXECUTABLE) $(JULIAHOME)/contrib/add_license_to_files.jl #add license headers
	@#Check documentation
	@$(JULIA_EXECUTABLE) $(JULIAHOME)/doc/NEWS-update.jl #Add missing cross-references to NEWS.md
	@$(MAKE) -C $(BUILDROOT)/doc html doctest=true linkcheck=true
	@$(MAKE) -C $(BUILDROOT)/doc pdf

	@# Check to see if the above make invocations changed anything important
	@if [ -n "$$(git status --porcelain)" ]; then \
		echo "Git repository dirty; Verify and commit changes to the repository, then retry"; \
		exit 1; \
	fi

	@#Check that netload tests work
	@#for test in test/netload/*.jl; do julia $$test; if [ $$? -ne 0 ]; then exit 1; fi; done
	@echo
	@echo To complete the release candidate checklist:
	@echo

	@echo 1. Remove deprecations in base/deprecated.jl
	@echo 2. Update references to the julia version in the source directories, such as in README.md
	@echo 3. Bump VERSION
	@echo 4. Increase SOMAJOR and SOMINOR if needed.
	@echo 5. Create tag, push to github "\(git tag v\`cat VERSION\` && git push --tags\)"		#"` # These comments deal with incompetent syntax highlighting rules
	@echo 6. Clean out old .tar.gz files living in deps/, "\`git clean -fdx\`" seems to work	#"`
	@echo 7. Replace github release tarball with tarballs created from make light-source-dist and make full-source-dist
	@echo 8. Check that 'make && make install && make test' succeed with unpacked tarballs even without Internet access.
	@echo 9. Follow packaging instructions in DISTRIBUTING.md to create binary packages for all platforms
	@echo 10. Upload to AWS, update https://julialang.org/downloads and http://status.julialang.org/stable links
	@echo 11. Update checksums on AWS for tarball and packaged binaries
	@echo 12. Announce on mailing lists
	@echo 13. Change master to release-0.X in base/version.jl and base/version_git.sh as in 4cb1e20
	@echo

$(build_man1dir)/julia.1: $(JULIAHOME)/doc/man/julia.1 | $(build_man1dir)
	@echo Copying in usr/share/man/man1/julia.1
	@mkdir -p $(build_man1dir)
	@cp $< $@

$(build_sysconfdir)/julia/startup.jl: $(JULIAHOME)/etc/startup.jl | $(build_sysconfdir)/julia
	@echo Creating usr/etc/julia/startup.jl
	@cp $< $@

$(build_datarootdir)/julia/julia-config.jl: $(JULIAHOME)/contrib/julia-config.jl | $(build_datarootdir)/julia
	$(INSTALL_M) $< $(dir $@)

$(build_depsbindir)/stringreplace: $(JULIAHOME)/contrib/stringreplace.c | $(build_depsbindir)
	@$(call PRINT_CC, $(HOSTCC) -o $(build_depsbindir)/stringreplace $(JULIAHOME)/contrib/stringreplace.c)

julia-base-cache: julia-sysimg-$(JULIA_BUILD_MODE) | $(DIRS) $(build_datarootdir)/julia
	@$(call spawn,JULIA_BINDIR=$(call cygpath_w,$(build_bindir)) $(JULIA_EXECUTABLE) --startup-file=no $(call cygpath_w,$(JULIAHOME)/etc/write_base_cache.jl) \
		$(call cygpath_w,$(build_datarootdir)/julia/base.cache))

# public libraries, that are installed in $(prefix)/lib
JL_TARGETS := julia
ifeq ($(BUNDLE_DEBUG_LIBS),1)
JL_TARGETS += julia-debug
endif

# private libraries, that are installed in $(prefix)/lib/julia
JL_PRIVATE_LIBS-0 := libccalltest libllvmcalltest
ifeq ($(USE_GPL_LIBS), 1)
JL_PRIVATE_LIBS-0 += libsuitesparse_wrapper
JL_PRIVATE_LIBS-$(USE_SYSTEM_SUITESPARSE) += libamd libcamd libccolamd libcholmod libcolamd libumfpack libspqr libsuitesparseconfig
endif
JL_PRIVATE_LIBS-$(USE_SYSTEM_PCRE) += libpcre2-8
JL_PRIVATE_LIBS-$(USE_SYSTEM_DSFMT) += libdSFMT
JL_PRIVATE_LIBS-$(USE_SYSTEM_GMP) += libgmp
JL_PRIVATE_LIBS-$(USE_SYSTEM_MPFR) += libmpfr
JL_PRIVATE_LIBS-$(USE_SYSTEM_LIBSSH2) += libssh2
JL_PRIVATE_LIBS-$(USE_SYSTEM_MBEDTLS) += libmbedtls libmbedcrypto libmbedx509
JL_PRIVATE_LIBS-$(USE_SYSTEM_CURL) += libcurl
JL_PRIVATE_LIBS-$(USE_SYSTEM_LIBGIT2) += libgit2
ifeq ($(OS),WINNT)
JL_PRIVATE_LIBS-$(USE_SYSTEM_ZLIB) += zlib
else
JL_PRIVATE_LIBS-$(USE_SYSTEM_ZLIB) += libz
endif
ifeq ($(USE_LLVM_SHLIB),1)
JL_PRIVATE_LIBS-$(USE_SYSTEM_LLVM) += libLLVM libLLVM-6
endif

ifeq ($(USE_SYSTEM_LIBM),0)
JL_PRIVATE_LIBS-$(USE_SYSTEM_OPENLIBM) += libopenlibm
endif

JL_PRIVATE_LIBS-$(USE_SYSTEM_BLAS) += $(LIBBLASNAME)
ifneq ($(LIBLAPACKNAME),$(LIBBLASNAME))
JL_PRIVATE_LIBS-$(USE_SYSTEM_LAPACK) += $(LIBLAPACKNAME)
endif

ifeq ($(OS),Darwin)
ifeq ($(USE_SYSTEM_BLAS),1)
ifeq ($(USE_SYSTEM_LAPACK),0)
JL_PRIVATE_LIBS-0 += libgfortblas
endif
endif
endif

# On FreeBSD, /lib/libgcc_s.so.1 is incompatible with Fortran; to use Fortran on FreeBSD,
# we need to link to the libgcc_s that ships with the same GCC version used by libgfortran.
# To work around this, we copy the GCC libraries we need, namely libgfortran, libgcc_s,
# and libquadmath, into our build library directory, $(build_libdir). We also add them to
# JL_PRIVATE_LIBS-0 so that they know where they need to live at install time.
ifeq ($(OS),FreeBSD)
define std_so
julia-deps: | $$(build_libdir)/$(1).so
$$(build_libdir)/$(1).so: | $$(build_libdir)
	$$(INSTALL_M) $$(GCCPATH)/$(1).so* $$(build_libdir)
JL_PRIVATE_LIBS-0 += $(1)
endef

$(eval $(call std_so,libgfortran))
$(eval $(call std_so,libgcc_s))
$(eval $(call std_so,libquadmath))
endif # FreeBSD

ifeq ($(OS),WINNT)
# find the standard .dll folders
ifeq ($(XC_HOST),)
STD_LIB_PATH ?= $(PATH)
else
STD_LIB_PATH := $(shell LANG=C $(CC) -print-search-dirs | grep programs | sed -e "s/^programs: =//")
STD_LIB_PATH += :$(shell LANG=C $(CC) -print-search-dirs | grep libraries | sed -e "s/^libraries: =//")
ifneq (,$(findstring CYGWIN,$(BUILD_OS))) # the cygwin-mingw32 compiler lies about it search directory paths
STD_LIB_PATH := $(shell echo '$(STD_LIB_PATH)' | sed -e "s!/lib/!/bin/!g")
endif
endif

pathsearch = $(firstword $(wildcard $(addsuffix /$(1),$(subst :, ,$(2)))))

define std_dll
julia-deps-libs: | $$(build_bindir)/lib$(1).dll $$(build_depsbindir)/lib$(1).dll
$$(build_bindir)/lib$(1).dll: | $$(build_bindir)
	cp $$(or $$(call pathsearch,lib$(1).dll,$$(STD_LIB_PATH)),$$(error can't find lib$1.dll)) $$(build_bindir)
$$(build_depsbindir)/lib$(1).dll: | $$(build_depsbindir)
	cp $$(or $$(call pathsearch,lib$(1).dll,$$(STD_LIB_PATH)),$$(error can't find lib$1.dll)) $$(build_depsbindir)
JL_TARGETS += $(1)
endef
julia-deps: julia-deps-libs

# Given a list of space-separated libraries, return the first library name that is
# correctly found through `pathsearch`.
define select_std_dll
$(firstword $(foreach name,$(1),$(if $(call pathsearch,lib$(name).dll,$(STD_LIB_PATH)),$(name),)))
endef

$(eval $(call std_dll,$(call select_std_dll,gfortran-3 gfortran-4 gfortran-5)))
$(eval $(call std_dll,quadmath-0))
$(eval $(call std_dll,stdc++-6))
ifeq ($(ARCH),i686)
$(eval $(call std_dll,gcc_s_sjlj-1))
else
$(eval $(call std_dll,gcc_s_seh-1))
endif
$(eval $(call std_dll,ssp-0))
$(eval $(call std_dll,winpthread-1))
$(eval $(call std_dll,atomic-1))
endif


define stringreplace
	$(build_depsbindir)/stringreplace $$(strings -t x - $1 | grep '$2' | awk '{print $$1;}') '$3' 255 "$(call cygpath_w,$1)"
endef

# Run fixup-libgfortran on all platforms but Windows and FreeBSD. On FreeBSD we
# pull in the GCC libraries earlier and use them for the build to make sure we
# don't inadvertently link to /lib/libgcc_s.so.1, which is incompatible with
# libgfortran, and on Windows we copy them in earlier as well.
ifeq (,$(findstring $(OS),FreeBSD WINNT))
julia-base: $(build_libdir)/libgfortran*.$(SHLIB_EXT)*
$(build_libdir)/libgfortran*.$(SHLIB_EXT)*: | $(build_libdir) julia-deps
	-$(CUSTOM_LD_LIBRARY_PATH) PATH="$(PATH):$(build_depsbindir)" $(JULIAHOME)/contrib/fixup-libgfortran.sh --verbose $(build_libdir)
JL_PRIVATE_LIBS-0 += libgfortran libgcc_s libquadmath
endif


install: $(build_depsbindir)/stringreplace $(BUILDROOT)/doc/_build/html/en/index.html

=== debian/changelog ===
julia (1.3.0+dfsg-2build1) focal; urgency=medium

  * No-change rebuild against libopenlibm3

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 25 Dec 2019 07:18:43 +0000

julia (1.3.0+dfsg-2) unstable; urgency=medium

  * Mark two symbols as x86 only. (thanks to Graham Inggs)
  * rules: Disable BLAS64 on arm64.
  * Temporarily make autopkgtest fail-permissive.

 -- Mo Zhou <cdluminate@gmail.com>  Sat, 14 Dec 2019 10:21:17 +0800

julia (1.3.0+dfsg-1) unstable; urgency=medium

  * New upstream version 1.3.0+dfsg
  * Patch Make.inc to fix openblas FTBFS on arm64
  * Refresh patches.
  * Update embedded libuv and Pkg.jl, as well as d/s/include-binaries.
  * B-D on p7zip and set USE_SYSTEM_P7ZIP=1.
  * Remove nonexisting files from julia.docs.
  * Update symbols control file.
  * B-D on zlib1g-dev and set USE_SYSTEM_ZLIB=1.
  * Remove unused patch: llvm-armhf-baseline.patch
  * Bump LLVM version to 8.
  * Reflect symbol changes resulted by the LLVM version bump.
  * Override two lintian warnings

 -- Mo Zhou <cdluminate@gmail.com>  Thu, 28 Nov 2019 19:26:55 +0800

julia (1.2.0+dfsg-1) unstable; urgency=medium

  * New upstream version 1.2.0+dfsg
  * Rebase/Refresh patches. Remove make-unwind-logic-error.patch.
  * Update the embedded Pkg.jl to 394e7c5d55d3722f5b2ab660ca0a694ea0041974
  * Disable binary builders via USE_BINARYBUILDER=0 .
  * Bump LLVM dependency to llvm-7-dev (Closes: #919593, #912792).
  * Update installation control files.
  * Refresh symbols list.
  * Patch: mask some failing tests.
  * Bundle OpenBLAS and SuiteSparse source tarballs. (USE_BLAS64 is enabled)
    Bundled OpenBLAS is specially compiled with SONAME=libopenblas64_.so,
    INTERFACE64=1 and all symbols suffixed by "64_". Bundled SuiteSparse
    is built against the bundled OpenBLAS with -DSUN64 extra CFLAG.
    (Closes: #910924, #930548)
    * Patch the suitesparse checksum.
    * Prevent Makefile from downloading openblas and suitesparse.
    * Update list of included-binaries
    * Remove OpenBLAS and SuiteSparse from B-D.
    * Remove libopenblas-base from runtime Depends.
    * shlibdeps.mk: Add several dependencies for openblas and suitesparse.
    * rules: Remove the LIBBLAS/LIBLAPACK build flags.
    * Update copyright information for embedded OpenBLAS, SuiteSparse.
    * Update the embedded OpenBLAS to 0.3.7
  * rules: Remove the if-clause that disables libunwind for s390x.
  * Exclude some libraries during shlibdeps resolution and dh_install.
  * Files-Excluded: exclude the whole contrib/windows directory.
  * Make tests fail-permissive.

 -- Mo Zhou <cdluminate@gmail.com>  Tue, 29 Oct 2019 20:08:37 +0800

=== debian/control ===
--- 
+++ 
@@ -12,23 +12,24 @@
 Build-Depends: curl,
                debhelper (>= 11~),
                dpkg-dev (>= 1.16.2~),
-               libblas-dev | libblas.so,
                libcurl4-gnutls-dev | libcurl-dev,
                libdsfmt-dev (>= 2.2.3),
                libgit2-dev (>= 0.27.0~),
                libgmp-dev,
-               liblapack-dev | liblapack.so,
                libmbedtls-dev,
                libmpfr-dev,
-               libopenblas-dev [amd64 arm64 armhf i386 kfreebsd-amd64 kfreebsd-i386 mips64el ppc64el s390x],
                libopenlibm-dev (>= 0.4.1+dfsg-4~) [any-i386 any-amd64 arm64 armhf mips mips64el mipsel powerpc ppc64 ppc64el],
                libpcre2-dev (>= 10.20-3~),
-               libsuitesparse-dev (>= 1:4.4.5),
                libunwind8-dev [!s390x],
                libutf8proc-dev (>= 2.1.1),
-               llvm-6.0-dev (>= 1:6.0.1-11),
+               llvm-8-dev,
                openssl,
-               unicode-data
+               p7zip,
+               unicode-data,
+               gfortran,
+               libblas-dev | libblas.so,
+               liblapack-dev | liblapack.so,
+               zlib1g-dev,
 Build-Depends-Indep: fonts-lato,
                      latexmk,
                      python3-pkg-resources,
@@ -74,9 +75,7 @@
 Pre-Depends: ${misc:Pre-Depends}
 Replaces: julia (<< 0.5.0~), libjulia0.6, libjulia0.7
 Breaks: julia (<< 0.5.0~), libjulia0.6, libjulia0.7
-Depends: libopenblas-base [amd64 arm64 armhf i386 kfreebsd-amd64 kfreebsd-i386 mips64el ppc64el s390x] | libatlas3-base [amd64 arm64 armel armhf hurd-i386 i386 kfreebsd-amd64 kfreebsd-i386 mips mips64el mipsel ppc64el s390x] | libmkl-rt [amd64 i386],
-         libopenblas-dev [amd64 arm64 armhf i386 kfreebsd-amd64 kfreebsd-i386 mips64el ppc64el s390x] | libatlas-base-dev [amd64 arm64 armel armhf hurd-i386 i386 kfreebsd-amd64 kfreebsd-i386 mips mips64el mipsel ppc64el s390x] | libmkl-dev [amd64 i386],
-         ${misc:Depends},
+Depends: ${misc:Depends},
          ${shlibs:Depends}
 Description: high-performance programming language for technical computing (runtime library)
  Julia is a high-level, high-performance dynamic programming language for

=== debian/rules ===
--- 
+++ 
@@ -34,13 +34,14 @@
 	MULTIARCH_INSTALL=1 \
 	NO_GIT=1 \
 	TAGGED_RELEASE_BANNER='$(DEB_VENDOR) ⛬  julia/$(DEB_VERSION)' \
-	USE_BLAS64=0  \
+	USE_BINARYBUILDER=0 \
+	USE_BLAS64=1  \
 	USE_LLVM_SHLIB=1 \
-	USE_SYSTEM_BLAS=1 \
+	USE_SYSTEM_BLAS=0 \
 	USE_SYSTEM_CURL=1 \
 	USE_SYSTEM_DSFMT=1 \
 	USE_SYSTEM_GMP=1 \
-	USE_SYSTEM_LAPACK=1 \
+	USE_SYSTEM_LAPACK=0 \
 	USE_SYSTEM_LIBGIT2=1 \
 	USE_SYSTEM_LIBSSH2=1 \
 	USE_SYSTEM_LIBUNWIND=1 \
@@ -49,10 +50,12 @@
 	USE_SYSTEM_MBEDTLS=1 \
 	USE_SYSTEM_MPFR=1 \
 	USE_SYSTEM_OPENSPECFUN=1 \
+	USE_SYSTEM_P7ZIP=1 \
 	USE_SYSTEM_PATCHELF=1 \
 	USE_SYSTEM_PCRE=1 \
-	USE_SYSTEM_SUITESPARSE=1 \
+	USE_SYSTEM_SUITESPARSE=0 \
 	USE_SYSTEM_UTF8PROC=1 \
+	USE_SYSTEM_ZLIB=1 \
 	VERBOSE=1
 
 # Set architecture specific CPU targets. See: #910784
@@ -62,6 +65,8 @@
 else ifneq (,$(filter $(DEB_HOST_ARCH),i386 hurd-i386 kfreebsd-i386))
 COMMON_FLAGS += MARCH=pentium4 \
 	JULIA_CPU_TARGET="pentium4;sandybridge,-xsaveopt,clone_all"
+else ifneq (,$(filter $(DEB_HOST_ARCH),arm64))
+COMMON_FLAGS += USE_BLAS64=0
 else ifneq (,$(filter $(DEB_HOST_ARCH),armhf))
 COMMON_FLAGS += JULIA_CPU_TARGET="armv7-a;armv7-a,neon;armv7-a,neon,vfp4"
 else ifneq (,$(filter $(DEB_HOST_ARCH),ppc64el))
@@ -82,19 +87,11 @@
 COMMON_FLAGS += USE_SYSTEM_OPENLIBM=0 USE_SYSTEM_LIBM=1
 endif
 
-# Use libopenblas on architectures that have it
-ifneq (,$(filter $(DEB_HOST_ARCH),amd64 arm64 armhf i386 kfreebsd-amd64 kfreebsd-i386 mips64el ppc64el s390x))
-COMMON_FLAGS += LIBBLAS=-lopenblas LIBBLASNAME=libopenblas \
-                LIBLAPACK=-lopenblas LIBLAPACKNAME=libopenblas
-else
+# Use libopenblas on architectures that have it.
 # Use libblas and liblapack elsewhere
+ifeq (,$(filter $(DEB_HOST_ARCH),amd64 arm64 armhf i386 kfreebsd-amd64 kfreebsd-i386 mips64el ppc64el s390x))
 COMMON_FLAGS += LIBBLAS=-lblas LIBBLASNAME=libblas \
                 LIBLAPACK=-llapack LIBLAPACKNAME=liblapack
-endif
-
-# [s390x] Disable libunwind
-ifneq (,$(filter $(DEB_HOST_ARCH),s390x))
-COMMON_FLAGS += DISABLE_LIBUNWIND=1
 endif
 
 # Set number of parallel workers for tests
@@ -134,7 +131,8 @@
 ifeq (,$(filter $(DEB_HOST_ARCH),amd64 i386))
 	-env $(TESTS_ENV) make -C test $(COMMON_FLAGS)
 else
-	env $(TESTS_ENV) make -C test $(COMMON_FLAGS)
+	#XXX: the dash is temporary
+	-env $(TESTS_ENV) make -C test $(COMMON_FLAGS)
 endif
 endif
 
@@ -167,6 +165,9 @@
 override_dh_compress:
 	dh_compress --exclude=examples/
 
+override_dh_install-arch:
+	dh_install -Xlibgcc_s -Xlibgfortran -Xlibquadmath
+
 override_dh_install-indep:
 	dh_install --exclude=build_h.jl --exclude=build.h
 
@@ -193,4 +194,5 @@
 	dh_strip -X"sys.so"
 
 override_dh_makeshlibs:
-	dh_makeshlibs --no-scripts -XLLVM
+	dh_makeshlibs --no-scripts -XLLVM -Xlibopenblas64_ -Xlibcolamd -Xlibumfpack \
+		-Xlibccolamd -Xlibcholmod -Xlibcamd -Xlibamd -Xlibspqr -Xlibsuitesparseconfig

## julia 1.3.1+dfsg

=== src/flisp/Makefile ===
SRCDIR := $(abspath $(dir $(lastword $(MAKEFILE_LIST))))
JULIAHOME := $(abspath $(SRCDIR)/../..)
BUILDDIR := .
include $(JULIAHOME)/Make.inc

JCFLAGS += $(CFLAGS)
JCXXFLAGS += $(CXXFLAGS)
JCPPFLAGS += $(CPPFLAGS)
JLDFLAGS += $(LDFLAGS)

NAME := flisp
EXENAME := $(NAME)
LIBTARGET := lib$(NAME)

SRCS := flisp.c builtins.c string.c equalhash.c table.c iostream.c \
        julia_extensions.c

LLTDIR := ../support
LLTSRCDIR := $(SRCDIR)/$(LLTDIR)
NATIVE_BUILDDIR :=
ifeq ($(BUILDING_HOST_TOOLS), 1)
NATIVE_BUILDDIR := $(BUILDDIR)/..
LLT_BUILDDIR := $(BUILDDIR)/../$(LLTDIR)/host
else
NATIVE_BUILDDIR := $(BUILDDIR)
LLT_BUILDDIR := $(BUILDDIR)/$(LLTDIR)
endif

HEADERS := $(wildcard *.h) $(LIBUV_INC)/uv.h $(wildcard $(LLTDIR)/*.h)

OBJS := $(SRCS:%.c=$(BUILDDIR)/%.o)
DOBJS := $(SRCS:%.c=$(BUILDDIR)/%.dbg.obj)
LLT_release := $(LLT_BUILDDIR)/libsupport.a
LLT_debug := $(LLT_BUILDDIR)/libsupport-debug.a
LIBFILES_release := $(LLT_release) $(LIBUV) $(LIBUTF8PROC)
LIBFILES_debug := $(LLT_debug) $(LIBUV) $(LIBUTF8PROC)
LIBS :=
ifneq ($(OS),WINNT)
LIBS += -lpthread
endif

FLAGS := -I$(LLTSRCDIR) $(JCFLAGS) $(HFILEDIRS:%=-I%) \
        -I$(LIBUV_INC) -I$(UTF8PROC_INC) -I$(build_includedir) $(LIBDIRS:%=-L%) \
        -DLIBRARY_EXPORTS -DUTF8PROC_EXPORTS
ifneq ($(USEMSVC), 1)
ifneq ($(OS), emscripten)
FLAGS += -DUSE_COMPUTED_GOTO
endif
FLAGS += -Wall -Wno-strict-aliasing -fvisibility=hidden -Wpointer-arith -Wundef
FLAGS += -Wold-style-definition -Wstrict-prototypes -Wc++-compat
endif

DEBUGFLAGS += $(FLAGS)
SHIPFLAGS += $(FLAGS)

default: release

release: $(BUILDDIR)/$(EXENAME)$(EXE)

debug: $(BUILDDIR)/$(EXENAME)-debug$(EXE)

$(BUILDDIR):
	mkdir -p $(BUILDDIR)

$(BUILDDIR)/%.o: $(SRCDIR)/%.c $(HEADERS) | $(BUILDDIR)
	@$(call PRINT_CC, $(CC) $(JCPPFLAGS) $(SHIPFLAGS) $(DISABLE_ASSERTIONS) -c $< -o $@)
$(BUILDDIR)/%.dbg.obj: $(SRCDIR)/%.c $(HEADERS) | $(BUILDDIR)
	@$(call PRINT_CC, $(CC) $(JCPPFLAGS) $(DEBUGFLAGS) -c $< -o $@)

FLISP_SRCS := $(flisp.c cvalues.c types.c flisp.h print.c read.c equal.c:%=$(SRCDIR)/%)
FLMAIN_SRCS := $(flmain.c flisp.h:%=$(SRCDIR)/%)
$(BUILDDIR)/flisp.o: $(FLISP_SRCS)
$(BUILDDIR)/flisp.dbg.obj: $(FLISP_SRCS)
$(BUILDDIR)/flmain.o: $(FLMAIN_SRCS)
$(BUILDDIR)/flmain.dbg.obj: $(FLMAIN_SRCS)

$(LLT_release): $(LLTSRCDIR)/*.h $(LLTSRCDIR)/*.c
	$(MAKE) -C $(NATIVE_BUILDDIR)/$(LLTDIR) $(subst $(abspath $(NATIVE_BUILDDIR)/$(LLTDIR))/,,$(abspath $(LLT_release)))
$(LLT_debug): $(LLTSRCDIR)/*.h $(LLTSRCDIR)/*.c
	$(MAKE) -C $(NATIVE_BUILDDIR)/$(LLTDIR) $(subst $(abspath $(NATIVE_BUILDDIR)/$(LLTDIR))/,,$(abspath $(LLT_debug)))

$(BUILDDIR)/$(LIBTARGET)-debug.a: $(DOBJS) | $(BUILDDIR)
	rm -rf $@
	@$(call PRINT_LINK, $(AR) -rcs $@ $(DOBJS))

$(BUILDDIR)/$(LIBTARGET).a: $(OBJS) | $(BUILDDIR)
	rm -rf $@
	@$(call PRINT_LINK, $(AR) -rcs $@ $(OBJS))

ifneq ($(USEMSVC), 1)
CCLD := $(CC)
else
CCLD := $(LD)
endif

$(BUILDDIR)/$(EXENAME)-debug$(EXE): $(DOBJS) $(LIBFILES_debug) $(BUILDDIR)/$(LIBTARGET)-debug.a $(BUILDDIR)/flmain.dbg.obj | $(BUILDDIR)/flisp.boot
	@$(call PRINT_LINK, $(CCLD) $(DEBUGFLAGS) $(JLDFLAGS) $(DOBJS) $(BUILDDIR)/flmain.dbg.obj -o $@ $(BUILDDIR)/$(LIBTARGET)-debug.a $(LIBFILES_debug) $(LIBS) $(OSLIBS))

$(BUILDDIR)/$(EXENAME)$(EXE): $(OBJS) $(LIBFILES_release) $(BUILDDIR)/$(LIBTARGET).a $(BUILDDIR)/flmain.o | $(BUILDDIR)/flisp.boot
	@$(call PRINT_LINK, $(CCLD) $(SHIPFLAGS) $(JLDFLAGS) $(OBJS) $(BUILDDIR)/flmain.o -o $@ $(BUILDDIR)/$(LIBTARGET).a $(LIBFILES_release) $(LIBS) $(OSLIBS))

$(BUILDDIR)/host/Makefile:
	mkdir -p $(BUILDDIR)/host
	@# add Makefiles to the build directories for convenience (pointing back to the source location of each)
	@echo '# -- This file is automatically generated in julia/src/flisp/Makefile -- #' > $@
	@echo 'BUILDDIR=$(BUILDDIR)/host' >> $@
	@echo 'BUILDING_HOST_TOOLS=1' >> $@
	@echo 'include $(SRCDIR)/Makefile' >> $@

$(BUILDDIR)/host/$(EXENAME): $(BUILDDIR)/host/Makefile
	make -C $(BUILDDIR)/host $(EXENAME)

ifneq ($(BUILDDIR)$(BUILDING_HOST_TOOLS),.)
$(BUILDDIR)/flisp.boot: $(SRCDIR)/flisp.boot | $(BUILDDIR)
	cp $< $@
endif

test:
ifneq ($(USEMSVC), 1)
	$(call spawn,./$(EXENAME)$(EXE)) unittest.lsp
endif

clean:
	rm -f $(BUILDDIR)/*.o
	rm -f $(BUILDDIR)/*.dbg.obj
	rm -f $(BUILDDIR)/*.a
	rm -f $(BUILDDIR)/$(EXENAME)$(EXE)
	rm -f $(BUILDDIR)/$(EXENAME)-debug$(EXE)
	rm -f $(BUILDDIR)/host/*

.PHONY: flisp-deps

=== debian/changelog ===
julia (1.3.1+dfsg-1) unstable; urgency=medium

  * New upstream version 1.3.1+dfsg
  * Upgrade embedded Pkg.jl to f71e2c5a119b9c850f9b357fc8c56068f5b51cc0.
  * Update my mail address and bump the year in copyright.

 -- Mo Zhou <lumin@debian.org>  Tue, 31 Dec 2019 16:30:40 +0800

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
 Maintainer: Debian Julia Team <pkg-julia-devel@lists.alioth.debian.org>
 Uploaders: Peter Colberg <peter@colberg.org>,
            Graham Inggs <ginggs@debian.org>,
-           Mo Zhou <cdluminate@gmail.com>
+           Mo Zhou <lumin@debian.org>
 Build-Depends: curl,
                debhelper (>= 11~),
                dpkg-dev (>= 1.16.2~),
